Subject: Re: tcp RST instead of FIN if child exits after parent closes path
From: "Max Bowsher" <[email-masked]>
To: "Brian White" <[email-masked]>
Cc: <[email-masked]>
Date: Tue, 15 Apr 2003 20:36:10 +0100

Brian White wrote:
>> [a good analysis, but the subject says it all, really, once a typo is
fixed
>> (s/exists/exits)]
>
> Oops!  :-)
>
>
>> Re: tcp RST instead of FIN if child exits after parent closes path
>>
>> This is a bug/feature of Windows Sockets. I think it would be possible to
>> craft a workaround in Cygwin, but it would require some non-trivial IPC.
>> (IIUC, you would need to maintain a cross-process refcount for the
socket).
>
> Hmmm...  From my work with Amanda, the child process can continue to
> send data via the socket even after the parent has closed it's handle
> on that path, so there must be some sort of reference counting already.

Yes, but the wrong sort.

To guarantee avoiding the RST, you need to shutdown(SHUT_WR) the socket. And
that does stop all processes from writing to the socket. So, you would need
to refcount the socket, and issue a shutdown just before the last close. (I
think.)

For a quick hack, you could try sleeping for a second before exiting. Should
work most of the time.

Max.

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/